(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = global || self, factory(global.FileUpload = {}));
}(this, (function (exports) { 'use strict';

	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//
	//

	var script = {
		props : {
			input_id_s : {
				type: String,
			},
			multiple_s : {
				type: Boolean,
				default: false
			},
			input_class_s : {
				type: String,
				default: ''
			},
			label_class_s : {
				type: String,
				default: ''				
			},
			preview_s : {
				type: Boolean,
				default: false
			},
			label_s : {
				type: String,
				default: "Select a File"
			},
			base_s : {
				type: Number,
				default: 2
			},
			max_size_s : {
				type: Number,
				default: 15
			},
			forceUpdateCounterS : Number,
			max_select_s : {
				type: Number,
				default: 10
			}

		},
		data: function data () {
			return {
				file : null,
				label_input: '',
				base_size: 1024,
				preview: '',
				allFiles : []
			}
		},
		
		created : function(){
			if(this.label_s != null || this.label_s !='')
			{
				this.label_input = this.label_s;
			}

		},
		methods : {
			readAndPreview: function readAndPreview(file, index, arr){
		        var this$1 = this;

		        var allFilest = [];
		        var size;
		        var reader = new FileReader();
				
				size = file.size && (file.size / Math.pow(this.base_size, 2));
				  
		      	// check file max size and force re-render the component, so that the variables are initialized to defaults.
			      if (size > this.max_size_s) {
					console.log("Max size");
			      	// trigger the event , when the size is exceeded the given val
					this.$emit('onMaxSize_s', file);

					// trigger the component key, to re-render the component
					this.$emit('forceRerenderFromSubC', this.forceUpdateCounterS, file);

			        
					return;
					
			      }
				  
				  allFilest[0] = file;

				  this.allFiles.push(file);
				
				  
				  reader.onload = function (e) {

					var dataURI = e.target.result;
					
			        if (dataURI) {

					  this$1.label_input = file.name;
					  allFilest[0].data = dataURI;

					  this$1.$emit('onFileLoaded_s', allFilest);
					  
					  this$1.preview = dataURI;
					  
					  this$1.allFiles[index].data = dataURI;


			        }
			    };//end onload
				// read blob url from file data
				
				
			    reader.readAsDataURL(file);
			},
			onChangeFile: function onChangeFile(e){
			  this.allFiles = [];
		      var files = e.target.files || e.dataTransfer.files;
		      if (!files.length) {
		        return;
		      }
		      if (files.length > this.max_select_s) {
		      	this.allFiles = [];
		      	this.showSnackbar();
		      	return;
		      }
		      if(files) {
		      	[].forEach.call(files, this.readAndPreview);
		      }
		      
		    },
		    showSnackbar: function showSnackbar() {
		    	var x = document.getElementById("snackbar");
			    x.className = "show";
			    setTimeout(function(){ x.className = x.className.replace("show", ""); }, 4000);
		    },
		},
	};

	function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
	/* server only */
	, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
	  if (typeof shadowMode !== 'boolean') {
	    createInjectorSSR = createInjector;
	    createInjector = shadowMode;
	    shadowMode = false;
	  } // Vue.extend constructor export interop.


	  var options = typeof script === 'function' ? script.options : script; // render functions

	  if (template && template.render) {
	    options.render = template.render;
	    options.staticRenderFns = template.staticRenderFns;
	    options._compiled = true; // functional template

	    if (isFunctionalTemplate) {
	      options.functional = true;
	    }
	  } // scopedId


	  if (scopeId) {
	    options._scopeId = scopeId;
	  }

	  var hook;

	  if (moduleIdentifier) {
	    // server build
	    hook = function hook(context) {
	      // 2.3 injection
	      context = context || // cached call
	      this.$vnode && this.$vnode.ssrContext || // stateful
	      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
	      // 2.2 with runInNewContext: true

	      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
	        context = __VUE_SSR_CONTEXT__;
	      } // inject component styles


	      if (style) {
	        style.call(this, createInjectorSSR(context));
	      } // register component module identifier for async chunk inference


	      if (context && context._registeredComponents) {
	        context._registeredComponents.add(moduleIdentifier);
	      }
	    }; // used by ssr in case component is cached and beforeCreate
	    // never gets called


	    options._ssrRegister = hook;
	  } else if (style) {
	    hook = shadowMode ? function () {
	      style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
	    } : function (context) {
	      style.call(this, createInjector(context));
	    };
	  }

	  if (hook) {
	    if (options.functional) {
	      // register for functional component in vue file
	      var originalRender = options.render;

	      options.render = function renderWithStyleInjection(h, context) {
	        hook.call(context);
	        return originalRender(h, context);
	      };
	    } else {
	      // inject component registration as beforeCreate hook
	      var existing = options.beforeCreate;
	      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
	    }
	  }

	  return script;
	}

	var normalizeComponent_1 = normalizeComponent;

	var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
	function createInjector(context) {
	  return function (id, style) {
	    return addStyle(id, style);
	  };
	}
	var HEAD = document.head || document.getElementsByTagName('head')[0];
	var styles = {};

	function addStyle(id, css) {
	  var group = isOldIE ? css.media || 'default' : id;
	  var style = styles[group] || (styles[group] = {
	    ids: new Set(),
	    styles: []
	  });

	  if (!style.ids.has(id)) {
	    style.ids.add(id);
	    var code = css.source;

	    if (css.map) {
	      // https://developer.chrome.com/devtools/docs/javascript-debugging
	      // this makes source maps inside style tags work properly in Chrome
	      code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

	      code += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) + ' */';
	    }

	    if (!style.element) {
	      style.element = document.createElement('style');
	      style.element.type = 'text/css';
	      if (css.media) { style.element.setAttribute('media', css.media); }
	      HEAD.appendChild(style.element);
	    }

	    if ('styleSheet' in style.element) {
	      style.styles.push(code);
	      style.element.styleSheet.cssText = style.styles.filter(Boolean).join('\n');
	    } else {
	      var index = style.ids.size - 1;
	      var textNode = document.createTextNode(code);
	      var nodes = style.element.childNodes;
	      if (nodes[index]) { style.element.removeChild(nodes[index]); }
	      if (nodes.length) { style.element.insertBefore(textNode, nodes[index]); }else { style.element.appendChild(textNode); }
	    }
	  }
	}

	var browser = createInjector;

	/* script */
	var __vue_script__ = script;

	/* template */
	var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"row"},[_c('div',{staticClass:"col-12 hc"},[_c('input',{class:_vm.input_class_s,attrs:{"type":"file","id":_vm.input_id_s,"multiple":_vm.multiple_s},on:{"change":_vm.onChangeFile}}),_vm._v(" "),_c('label',{class:_vm.label_class_s,attrs:{"id":"inputLabelCSS","title":_vm.label_input,"for":_vm.input_id_s}},[_vm._v(_vm._s(_vm.label_input))])]),_vm._v(" "),_c('div',{attrs:{"id":"snackbar"}},[_vm._v("You cannot select more than "+_vm._s()+"5 files.")]),_vm._v(" "),(_vm.preview_s)?_c('div',{staticClass:"col-12"},[_c('img',{staticClass:"img-fluid",attrs:{"src":_vm.preview}})]):_vm._e()])};
	var __vue_staticRenderFns__ = [];

	  /* style */
	  var __vue_inject_styles__ = function (inject) {
	    if (!inject) { return }
	    inject("data-v-16eff87c_0", { source: ".hc>input[type=file]{display:none}#inputLabelCSS{color:#2f4f4f;text-overflow:ellipsis;overflow:hidden;white-space:nowrap}#snackbar{visibility:hidden;min-width:250px;margin-left:-125px;background-color:rgba(21,21,21,.37);color:#fff;text-align:center;border-radius:2px;padding:10px;position:fixed;z-index:1;left:50%;bottom:30px;font-size:17px}#snackbar.show{visibility:visible;-webkit-animation:fadein .5s,fadeout .5s 2.5s;animation:fadein .5s,fadeout .5s 2.5s}", map: undefined, media: undefined });

	  };
	  /* scoped */
	  var __vue_scope_id__ = undefined;
	  /* module identifier */
	  var __vue_module_identifier__ = undefined;
	  /* functional template */
	  var __vue_is_functional_template__ = false;
	  /* style inject SSR */
	  

	  
	  var SubFileUpload = normalizeComponent_1(
	    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
	    __vue_inject_styles__,
	    __vue_script__,
	    __vue_scope_id__,
	    __vue_is_functional_template__,
	    __vue_module_identifier__,
	    browser,
	    undefined
	  );

	//

	var script$1 = {

	  name: "FileUpload",
	  components : {
	    "sub-file-upload" : SubFileUpload
	  },
	  props: [ "input_class" , "multiple_file_upload" ,"preview_file" , "label_input" , "base_val" , "max_file_size" , "id" , "label_class" ,"max_select_file", "UpdateCounter"],
	  data: function data() {
	    return {
	      forceUpdateCounter:0,
	    }
	  },
	  methods : {
	        forceRerender: function forceRerender(val, file) {
	          this.forceUpdateCounter += 1;  
	        },
	        maxSizeLimit: function maxSizeLimit(val) {
	          this.$emit('maxSizeLimit',val);
	        },
	        onfileLoaded: function onfileLoaded(val) {
	          this.$emit('fileLoaded',val);
	        }

	  },
	};

	/* script */
	var __vue_script__$1 = script$1;

	/* template */
	var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('sub-file-upload',{key:_vm.UpdateCounter,attrs:{"input_id_s":_vm.id,"forceUpdateCounterS":_vm.forceUpdateCounter,"multiple_s":_vm.multiple_file_upload,"input_class_s":_vm.input_class,"preview_s":_vm.preview_file,"label_s":_vm.label_input,"label_class_s":_vm.input_class,"base_s":_vm.base_val,"max_size_s":_vm.max_file_size,"max_select_s":_vm.max_select_file},on:{"forceRerenderFromSubC":_vm.forceRerender,"onMaxSize_s":_vm.maxSizeLimit,"onFileLoaded_s":_vm.onfileLoaded}})],1)};
	var __vue_staticRenderFns__$1 = [];

	  /* style */
	  var __vue_inject_styles__$1 = undefined;
	  /* scoped */
	  var __vue_scope_id__$1 = undefined;
	  /* module identifier */
	  var __vue_module_identifier__$1 = undefined;
	  /* functional template */
	  var __vue_is_functional_template__$1 = false;
	  /* style inject */
	  
	  /* style inject SSR */
	  

	  
	  var component = normalizeComponent_1(
	    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
	    __vue_inject_styles__$1,
	    __vue_script__$1,
	    __vue_scope_id__$1,
	    __vue_is_functional_template__$1,
	    __vue_module_identifier__$1,
	    undefined,
	    undefined
	  );

	// ./src/index.js

	function install(Vue) {
	  if (install.installed) { return; }
	  install.installed = true;
	  Vue.component("FileUpload", component);
	}

	var plugin = {
	  install: install
	};

	var GlobalVue = null;
	if (typeof window !== "undefined") {
	  GlobalVue = window.Vue;
	} else if (typeof global !== "undefined") {
	  GlobalVue = global.vue;
	}

	if (GlobalVue) {
	  GlobalVue.use(plugin);
	}

	component.install = install;

	exports.default = component;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
